#!/bin/bash

INDEXFILE=index.shtml

#BASEDIR=`pwd`
BASEDIR=~/scripts/web/clunkgal
SUBDIR='photos'
SITEROOT="/var/www/clunker.dyndns.org"
GALLERY="$SITEROOT/$SUBDIR"
IMGDIR="/images"
SUBDIRSPERROW=5
THUMBSPERROW=4
THUMBSIZE=150x100
MANIPSIZE=x600

# Copy folder image

cp $BASEDIR/templ_icon_folder.png  $SITEROOT/$IMGDIR
cp $BASEDIR/templ_icon_up.png      $SITEROOT/$IMGDIR
cp $BASEDIR/templ_icon_back.png    $SITEROOT/$IMGDIR
cp $BASEDIR/templ_icon_forward.png $SITEROOT/$IMGDIR

parentpic="$IMGDIR/templ_icon_up.png"

# Build the list of directories to recurse through

for rawdir in `find $GALLERY -name '.manip' -o -name '.thumb' -o -name '.html' -prune -o -type d -print | sort | tr ' ' '@'`
do
  dir=`echo $rawdir | sed 's/@/ /g'`
  nicedir=`echo $dir | sed 's/.*\///'`
  COUNT=0
  cd "$dir"
  (
    echo '<!--#set var="pagetitle" value="the haberdashery: photos: '$nicedir'" -->'
    cat $BASEDIR/templ_dir.shtml
    echo '<div class="gallery-content">' 
    echo '<table cellpadding="4"><div id="subdirs"><tr>'
    echo '<td>'
    echo '<a href=".."><img src='$parentpic'><br><b>Go up</b></a>'
    echo '</td>'
  ) > $INDEXFILE

  for templatedir in .manip .thumb .html
  do
    if [ -d $templatedir ]; then
      rm -rf $templatedir
    fi
  done


# Now enumerate directories below this one to display subdir hyperlinks

  for rawsubdir in `find -maxdepth 1 -name '.' -o -name '.manip' -o -name '.thumb' -o -name '.html' -prune -o -type d -print | sort | tr ' ' '@'`
  do
    subdir=`echo $rawsubdir | sed 's/@/ /g'`
    nicesubdir=`echo $subdir | sed 's/.\///'`
    let COUNT=COUNT+1
    let SPLIT=COUNT%SUBDIRSPERROW
    if [ "$SPLIT" -eq "0" ]; then
      echo '</tr><tr>' >> $INDEXFILE
    fi
    (
      echo '<td>'
      folderpic="$IMGDIR/templ_icon_folder.png"
      echo '<a href="'$nicesubdir'"><img src="'$folderpic'"><br>'$nicesubdir'</a>'
      echo '</td>'
    ) >> $INDEXFILE
  done
  echo '</tr></div></table><hr>' >> $INDEXFILE

  COUNT=0
  (
    echo '<table>'
    echo '<div id="photos"><tr>'
    echo '<td bgcolor="black" width="150">'
    echo 'In folder:<br><i><b>'$nicedir'</b></i>'
    echo '</td>'
  ) >> $INDEXFILE
  mkdir .thumb  .manip  .html

  TOTAL=0
  for countphoto in *.{jpg,JPG,png,PNG}
  do
    if [ -f "$countphoto" ]; then
      let TOTAL=TOTAL+1
    fi
  done

  for photo in *.{jpg,JPG,png,PNG}
  do
    if [ -f "$photo" ]; then
      LAST=$COUNT
      let COUNT=COUNT+1
      let NEXT=COUNT+1

      if [ $LAST -lt 1 ]; then
        LAST=".."
      else
        LAST="$LAST.shtml"
      fi
      if [ $NEXT -gt $TOTAL ]; then
        NEXT=".."
      else
        NEXT="$NEXT.shtml"
      fi

      convert -resize $THUMBSIZE "$photo" .thumb/thumb_$COUNT
      convert -resize $MANIPSIZE "$photo" .manip/manip_$COUNT

      let SPLIT=COUNT%THUMBSPERROW
      if [ "$SPLIT" -eq "0" ]; then
        echo '</tr><tr>' >> $INDEXFILE
      fi

      nicephoto=`echo $photo | sed "s/\..*//"`
  
      (
        echo '<td>'
        echo '<a href=".html/'$COUNT'.shtml"><img src=".thumb/thumb_'$COUNT'"></a>'
        echo '</td>'
      ) >> $INDEXFILE
      PHOTOFILE=".html/$COUNT.shtml"
      echo "Processing '$nicephoto' ($COUNT of $TOTAL in folder '$nicedir')"
      (
        echo '<!--#set var="pagetitle" value="the haberdashery: photos: '$nicedir'" -->'
        cat $BASEDIR/templ_photo.shtml
        echo '<div class="gallery-content">' 
        echo '<b><a href="'$LAST'"><img src="'$IMGDIR'/templ_icon_back.png"></a> <a href=".."><img src="'$IMGDIR'/templ_icon_up.png"></a> <a href="'$NEXT'"><img src="'$IMGDIR'/templ_icon_forward.png"></a> | Title: </b>'$nicephoto
        echo '<a href="'$NEXT'"><img src="../.manip/manip_'$COUNT'" border=0></a>'
      ) > "$PHOTOFILE"
    fi
  done

  echo '</tr></table>' >> $INDEXFILE

done
